#### connect (7 of 12 overloads)

Establishes a socket connection by trying each endpoint in a sequence.

    template<
        typename Protocol,
        typename Executor,
        typename EndpointSequence,
        typename ConnectCondition>
    Protocol::endpoint connect(
        basic_socket< Protocol, Executor > & s,
        const EndpointSequence & endpoints,
        ConnectCondition connect_condition,
        typename enable_if< is_endpoint_sequence< EndpointSequence >::value >::type *  = 0);

This function attempts to connect a socket to one of a sequence of endpoints. It does this by repeated calls to the socket's `connect` member function, once for each endpoint in the sequence, until a connection is successfully established.

###### Parameters

s

  The socket to be connected. If the socket is already open, it will be closed.

endpoints

  A sequence of endpoints.

connect_condition

  A function object that is called prior to each connection attempt. The signature of the function object must be:

      bool connect_condition(
          const asio::error_code& ec,
          const typename Protocol::endpoint& next);

  The `ec` parameter contains the result from the most recent connect operation. Before the first connection attempt, `ec` is always set to indicate success. The `next` parameter is the next endpoint to be tried. The function object should return true if the next endpoint should be tried, and false if it should be skipped.

###### Return Value

The successfully connected endpoint.

###### Exceptions

asio::system_error

  Thrown on failure. If the sequence is empty, the associated `error_code` is `asio::error::not_found`. Otherwise, contains the error from the last connection attempt.

###### Example

The following connect condition function object can be used to output information about the individual connection attempts:

    struct my_connect_condition
    {
      bool operator()(
          const asio::error_code& ec,
          const::tcp::endpoint& next)
      {
        if (ec) std::cout << "Error: " << ec.message() << std::endl;
        std::cout << "Trying: " << next << std::endl;
        return true;
      }
    };

It would be used with the `asio::connect` function as follows:

    tcp::resolver r(my_context);
    tcp::resolver::query q("host", "service");
    tcp::socket s(my_context);
    tcp::endpoint e = asio::connect(s,
        r.resolve(q), my_connect_condition());
    std::cout << "Connected to: " << e << std::endl;